<?php  defined('_JEXEC') or die( 'Restricted access' );

/**
 * @version 2.0 $Id: webcategory.php,v 1.12 2011-04-07 18:54:31 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport('joomla.application.component.model');

class LinkDirectory2ModelWebcategory extends JModel{

	private $_id = null;
	private $_data = null;
	
	/**
	 * 
	 */
	public function __construct() {
		parent::__construct();
		$array = JRequest::getVar('cid', array(0), '', 'array');
		$edit	= JRequest::getVar('edit',true);
		if($edit){
			$this->setId((int)$array[0]);
		}
	}

	/**
	 * 
	 */
	private function setId($id){
		$this->_id		= $id;
		$this->_data	= null;
	}

	/**
	 * 
	 */
	public function &getData() {
		if ($this->_loadData()) {
			// TODO Ist das (noch) nötig?
			$user = &JFactory::getUser();
			if ($this->_data->access > $user->get('aid', 0)) {
				JError::raiseError( 403, JText::_('ALERTNOTAUTH') );
				return;
			}
		}
		else {
			$this->_initData();
		}
		return $this->_data;
	}
	
	/**
	 * (un)published in Abhängigkeit der Vater- beziehungsweise Kindbeziehungen.
	 * Bei welchen Kategorien keine Änderung möglich war, kann TODO momentan nicht ermittelt werden.  
	 *
	 * @param Array<int> $cid
	 * @param int $publish 0 für unpublish, 1 für publish
	 * @return false bei DB-Fehlern, sonst true
	 */
	public function publish( $cid = array(), $publish = 1 ) {
		$user 	=& JFactory::getUser();
		if (count( $cid )) {
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );

			$publish = intval( $publish );
			$sumAffectedRows = 0;
			if ($publish) {
				// Nur die aktivieren, deren Väter veröffentlich sind. Rekursiv so lange
				// durchführen, bis keine updates mehr erfolgen.
				$query = "UPDATE #__ldcats c, #__ldcats cc"
				. " SET c.published = " . intval( $publish )
				. " WHERE c.id IN ( $cids )"
				. " AND ( c.checked_out = 0 OR  c.checked_out = $user->id ) " 
				. " AND ( ( cc.id = c.parent_id AND cc.published = 1 ) OR c.parent_id = 0 )"
				;
				do {
					$this->_db->setQuery( $query );
					if (!$this->_db->query()) {
						$this->setError($this->_db->getErrorMsg());
						return false;
					}
					$affectedRows = $this->_db->getAffectedRows();
					$sumAffectedRows+= $affectedRows;
				}  while ( $affectedRows  > 0);
			} else {
				// nur die "deaktiviren, der keine veröffendliche Kinder haben / haben werden bzw. keine Kinder haben
				//
				// 1. und nun alle die, die keine Kinder haben
				$query =  "UPDATE #__ldcats AS c "
					. " LEFT JOIN #__ldcats AS cc "
					. " ON cc.parent_id=c.id "
					. " SET c.published = " . intval( $publish )
					. " WHERE cc.id is NULL "
					. " AND c.id IN ( $cids )"
					. " AND ( c.checked_out = 0 OR  ( c.checked_out = $user->id )  ) "
					;
				$this->_db->setQuery( $query );
				if (!$this->_db->query()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
				// 2. Alle, die keine veröffentlichen Kinder haben bzw. haben werden
				// wir müssen jetzt rekursiv durch
				do {
					// alle IDs ermittln. die auf unbublish gesetzt  werden dürfen
					$query = "select c.parent_id from #__ldcats c, #__ldcats cc "
						. " where c.parent_id = cc.id "
						. " and c.parent_id in ($cids) "
						. " and cc.published = 1  group by c.parent_id  having max(c.published) = 0 ";
				
					$this->_db->setQuery( $query );
					$ids = $this->_db->loadResultArray();
					if ($ids == null) break;
					$ids_sql = implode( ',', $ids );
				
					// Nun das eigentlichen Update durechführen
					$query = "UPDATE #__ldcats c"
						. " SET c.published = 0 "
						. " WHERE c.id IN ( $ids_sql )"
						. " AND ( c.checked_out = 0 OR ( c.checked_out = $user->id ) ) "
						;
				
					$this->_db->setQuery( $query );
					if (!$this->_db->query()) {
						$this->setError($this->_db->getErrorMsg());
						return false;
					}
				} while ( $this->_db->getAffectedRows() > 0 );		
			}
			$this->checkIfPublishedChange($cid,$publish);
		} // if (count( $cid ))
		return true;
	}
	
	/**
	 *
	 */
	public function move($direction) {
		$row =& $this->getTable();
		if (!$row->load($this->_id)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		if (!$row->move( $direction)) {//, ' catid = '.(int) $row->catid.' AND published >= 0 ' )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		return true;
	}	
	
	/**
	 * Schreibt für jede Kategorie, bei der publish nicht geändert wurde, einen Error, der den Namen der Kategorie enthält.
	 *
	 * @param array(int) $cid Kategorie-Ids, dessen publish geändert werden sollte
	 * @param boolean $publish Wert, auf den Publish gesetzt werden sollte
	 */
	private function checkIfPublishedChange($cid,$publish){
		if (count( $cid )) {
			$cids = implode( ',', $cid );
			$query =  'SELECT c.id , c.name FROM #__ldcats c ' 
				. ' WHERE  c.published != ' . $publish 
				. ' AND id in ( ' . $cids . ' )'
				;
			$this->_db->setQuery( $query );
			$nonChangeCategories = $this->_db->loadObjectList();
		
			if ($nonChangeCategories){
				foreach ($nonChangeCategories as $nonChangeCategory ){
					$this->setError($nonChangeCategory->name);
				}
			}	
		}
	}
	
	/**
	 * 
	 */
	public function checkout($uid = null) {
		if ($this->_id) {
			if (is_null($uid)) {
				$user	=& JFactory::getUser();
				$uid	= $user->get('id');
			}
			$row = & $this->getTable();
			if(!$row->checkout($uid, $this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			return true;
		}
		return false;
	}
	
	/**
	 * 
	 */
	public function checkin() {
		if ($this->_id) {
			$row = & $this->getTable();
			if(! $row->checkin($this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
			return true;
		}
		return true;
	}
	
	/**
	 * Speichert eine webcaegory. Bei einem Fehler wird false zurückgeliefert, ansonsten immmer true.
	 * Wenn das Setzen von published Aufgrund des Kontextes (Beziehungen zu Kind bzw. ELtern-Elementen) 
	 * nicht möglich ist, wird zwar true zurückgegeben, aber getError liefert eine 
	 * entsprechende Information. 
	 *
	 * @param  $data
	 * @return true, wenn erfolgreich gespeichert, sonst false
	 */
	public function store($data) {
		$row =& $this->getTable();
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}	
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		if (!$row->_id) {
			$where = "parent_id = " . (int) $row->parent_id;
			$row->ordering = $row->getNextOrder( $where );
		}	
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		} 
		if ($row->getError()){
			$this->setError($row->getError());
		}
		return true;
	}
	
	public function insert($data) {
		$row =& $this->getTable();
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}	
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		if (!$row->id) {
			$where = "parent_id = " . (int) $row->parent_id;
			$row->ordering = $row->getNextOrder( $where );
		}	
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		} 
		$id = $this->_db->insertid();
		if ($row->getError()){
			$this->setError($row->getError());
		}
		return $id;
	}
	
	
	/**
	 *
	 */
	public function saveorder($cid = array(), $order) {
		$row =& $this->getTable();
		$groupings = array();
		for( $i=0; $i < count($cid); $i++ ) {
			$row->load( (int) $cid[$i] );
			$groupings[] = $row->parent_id;
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}
		// execute updateOrder for each parent group
		$groupings = array_unique( $groupings );
		foreach ($groupings as $group){
			$row->reorder('parent_id = '.(int) $group);
		}
		return true;
	}
	
	/**
	 * Löscht Kategorien. Dies ist nur dann möglich, wenn die Kategorien keine 
	 * Links und keine Kategorien enthält. Das Löschen erfolgt rekursive. Abbruch, wenn 
	 * kein Löschen mehr möglich ist
	 * 
	 * Kategorien, die nicht gelöscht werden können, können mit getErrors() abgerufen werden.
	 *
	 * @param Array<int> $cid Kategorien-Ids, die gelöscht werden sollen
	 * @return false, wenn das Löschen mit einem SQL-Fehler abgebrochen wurde. 
	 * 
	 */
	public function delete($cid) {
		if (count( $cid ) < 1) {
			return  true;
		}
		$cids = implode( ',', $cid );
		$deleteAnEntry = false;
		do {
			$deleteAnEntry = false;
			$categoriesWithLinks=$this->getTotalLinks($cids);
			$categoriesWithSubCategories=$this->getTotalSubCats($cids);
			if ( ($categoriesWithLinks === false) || ($categoriesWithSubCategories === false)){
				return true;
			}
			$cidForDelete=$this->determineDeletableCategoryIds($categoriesWithLinks,$categoriesWithSubCategories);
			if (count( $cidForDelete )) {
				$cidsForDelete = implode( ',', $cidForDelete );
				$query = 'DELETE FROM #__ldcats '
					.  " WHERE id IN ( $cidsForDelete )"
				;
				 
				$this->_db->setQuery($query);
				if (!$this->_db->query()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
				if ($this->_db->getAffectedRows() > 0){
					$deleteAnEntry=true;
				}
			}	
		} while ($deleteAnEntry);
		$this->setCanNotDeleteWarning($categoriesWithLinks, $categoriesWithSubCategories);
		return true;
	}
	
	/**
	 * Liefert true, wenn Weblink von einem anderen User ausgecheckt worden ist, sonst false.  
	 */
	public function isCheckedOut( $userId=0 ) {
		if ($userId === 0) {
			$user		= &JFactory::getUser();
			$userId		= (int) $user->get('id');
		}
		if ($this->_loadData()) {
			if ($userId) {
				//       true, wenn ausgescheckt  && true, wenn von einem anderen ausgescheckt    
				return ($this->_data->checked_out && $this->_data->checked_out != $userId);
			} else {
				return $this->_data->checked_out;
			}
		}
	}
	
	public function &searchByName($name='',$parrendId){
		$sql = 'select * FROM #__ldcats where name = ' . $this->_db->Quote($name) . ' AND parent_id = ' . intval($parrendId);
		$this->_db->setQuery($sql);
		$foundEntry =  $this->_db->loadObject();
		if (!$foundEntry ) {
			$this->setError($this->_db->getErrorMsg());
		}	
		return $foundEntry;
	}
	
	private function setCanNotDeleteWarning($categoriesWithLinks, $categoriesWithSubCategories){
		foreach ($categoriesWithLinks as $row){
			if ($row->numlinks){
				$this->setError(JText::sprintf("CAN NOT DELETE CATEGORY [N]. CATEGORY CONTAIN [N] WEBLINKS.", $row->name, $row->numlinks ));
			}
		}
		foreach ($categoriesWithSubCategories as $row){
			if ($row->numsubcats){
				$this->setError(JText::sprintf("CAN NOT DELETE CATEGORY [N]. CATEGORY CONTAIN [N] SUBCATEGORIES.", $row->name, $row->numsubcats ));
			}
		}
	}

	private function getTotalLinks($cids){
		$query = 'SELECT c.id, c.name, COUNT( l.catid ) AS numlinks FROM #__ldcats AS c ' 
				. ' LEFT JOIN #__ldlinks AS l ON l.catid = c.id ' 
				. ' WHERE c.id IN ( ' . $cids . ')' 
				. ' GROUP BY c.id '
				//. ' HAVING COUNT( l.catid ) > 0 '
				;
		$this->_db->setQuery( $query );
		$categoriesWithLinks = $this->_db->loadObjectList();
		if (!$categoriesWithLinks ) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}		
		return $categoriesWithLinks;
	}
	
	private function getTotalSubCats($cids){
		$query = ' SELECT c.id, c.name, COUNT( cc.parent_id ) AS numsubcats FROM #__ldcats AS c ' 
	          	. ' LEFT JOIN #__ldcats AS cc ON cc.parent_id = c.id ' 
	          	.'  WHERE c.id IN ( '.$cids . ')' 
	          	. ' GROUP BY c.id '
	          	//. ' HAVING COUNT( cc.parent_id ) > 0 '
			 	;
		
		$this->_db->setQuery( $query );
		$categoriesWithSubCategories = $this->_db->loadObjectList();
		if (!$categoriesWithSubCategories ) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		return $categoriesWithSubCategories;
	}
	
	private function determineDeletableCategoryIds($categoriesWithLinks,$categoriesWithSubCategories){
		$cidForDeleteNonLinks = array();
		$$cidForDeleteNonSubCats = array();
		foreach ($categoriesWithLinks as $row) {
			if ($row->numlinks == 0) {
				$cidForDeleteNonLinks[] = $row->id;
			}
		}
		foreach ($categoriesWithSubCategories as $row) {
			if ($row->numsubcats == 0) {
				$cidForDeleteNonSubCats[] = $row->id;
			} 
		}			
		$cidForDelete=array_intersect($cidForDeleteNonSubCats,$cidForDeleteNonLinks);
		return $cidForDelete;
	}
		
	private function _loadData() { 
		if (empty($this->_data)) {
			$query = 'SELECT a.* ' .
					' FROM #__ldcats AS a' .
					' WHERE a.id = '.(int) $this->_id;
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			return (boolean) $this->_data;
		}
		return true;
	}

	private function _initData() {
		if (empty($this->_data)) {
			$webcategory = new stdClass();
			$webcategory->id = 0;
			$webcategory->parent_id = 0;
			$webcategory->title = null;
			$webcategory->name = null;
			$webcategory->image = null;
			$webcategory->description = null;
			$webcategory->published = null;
			$webcategory->checked_out = null;
			$webcategory->checked_out_time = null;
			$webcategory->editor = null;
			$webcategory->ordering = null;
			$webcategory->access = null;
			$webcategory->count = null;
			$webcategory->params = null;
			$this->_data = $webcategory;
			return (boolean) $this->_data;
		}
		return true;
	}
}
?>