<?php defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * @version 2.0 $Id: LinkdirectoryURL.php,v 1.8 2010-02-08 20:47:28 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

class LinkdirectoryURL {

	public function getURL($view,$task){
		return LinkdirectoryURL::_getURL($view,$task);
	}

	/**
	 * Link zur Deatil-Seite. mit Task legt man fest, ob dabei auch die entsprechenden 
	 * Formulare für z.B. Bewertung zusätzlich mit angezeigt werden soll.
	 * @param String $view. mgliche Werte sind 'view'
	 * @param String $task Task, mögliche Werte sind 'comment', 'rate', 'report', null
	 * @param int $id Item des Links
	 * @return URL zur jeweilgen Seite
	 */
	public function getItemURL($view,$task, $id){
		return LinkdirectoryURL::_getURL($view,$task,'id='.intval($id));
	}

	/**
	 * Link zu einer Kategorie mit den Tasks 'viewcat' und 'new'
	 *
	 * @param String $task Task
	 * @param int $catid Id des jeweiligen Kategorie
	 * @return URL zur jeweiligen Seite
	 */
	public function getCatURL($view, $task, $catid){
		return LinkdirectoryURL::_getURL($view, $task, 'catid='.intval($catid));
	}

	public function getLinkAndCatUrl($task, $id,$catid){
		return LinkdirectoryURL::_getURL($task,'id='.intval($id).'&catid='.intval($catid));
	}

	public function getSearchURL($task, $searchtext,$searchtype,$catid){
		return LinkdirectoryURL::_getURL($task,null,'searchtext='.$searchtext.'&searchtype='.$searchtype.'&catid='.$catid);
	}

	private function _getURL($view,$task,$other='') {
		global $Itemid;
		$_other ='';
		$_task='';
		$_view='';
		$_itemid='';
		if ($other)  $_other ='&'.$other;
		if ($view )  $_view  ='&view='.$view;
		if ($task )  $_task  ='&task='.$task;
		if ($Itemid) $_itemid= '&Itemid='.$Itemid;
		return $url='index.php?option=com_linkdirectory2'. $_view . $_task . $_other . $_itemid;
	}

	/**
	 * Liefert die URL eines Links in Abhängigkeit von linkDisplayMode ("Web Link Stil" oder "Direkte URL") 
	 *
	 * @param String $url URL des Links
	 * @param int $id Id des Links
	 * @return Liefert die URL eines Links in Abhängigkeit von linkDisplayMode
	 */
	public function getUrlToLink($url,$id){
		require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'LDConfig.php';
		$ld=new LDConfig();
		if ($ld->linkDisplayMode) {
			return $url;
		} else {
			return LinkdirectoryURL::getItemUrl('link','view',$id);
		}
	}
}
?>