<?php defined('_JEXEC') or die('Restricted access');

/**
 * @version 2.0 $Id: ViewUtils.php,v 1.14 2010-09-26 21:37:58 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

class ViewUtils {
	
	/**
	 * Liefert JParameter des aktiven Menü-Eintrages inkl. ggf. gesetzem Property 'page_title'.  
	 *
	 * @param  $row Weblink
	 * @return JParameter mit allen Menü-Paramtern inkl. ggf. gesetztem Property page_title 
	 */
	public static function &setPageTitleForLink(&$rowWeblink, $displayDynamicPageTitel){
		$params=self::getPageTitleFromMenu();
		$document =& JFactory::getDocument();
		$document->setTitle( self::buildLinkPageTitleForHtmlHead($params, $rowWeblink, $displayDynamicPageTitel) );
		return $params;
	}

	/**
	 * Liefert JParameter des aktiven Menü-Eintrages inkl. ggf. gesetzem Property 'page_title'.  
	 *
	 * @param  $row Weblink
	 * @return JParameter mit allen Menü-Paramtern inkl. ggf. gesetztem Property page_title 
	 */
	public static function &setPageTitleForCategories(&$parentCategoryTitle, $displayDynamicPageTitel){
		$params=self::getPageTitleFromMenu();
		$document =& JFactory::getDocument();
		$document->setTitle( self::buildCategoiesPageTitleForHtmlHead($params, $parentCategoryTitle, $displayDynamicPageTitel));
		return $params;
	}
	
	/**
	 * Liefert JParameter des aktiven Menü-Eintrages inkl. ggf. gesetzem Property 'page_title'.  
	 *
	 * @param  $row Weblink
	 * @return JParameter mit allen Menü-Paramtern inkl. ggf. gesetztem Property page_title 
	 */
	public static function &setPageTitleForSearch($searchtext, $displayDynamicPageTitel){
		$params=self::getPageTitleFromMenu();
		$document =& JFactory::getDocument();
		$document->setTitle( self::buildSearchPageTitleForHtmlHead($params, $searchtext, $displayDynamicPageTitel));
		return $params;
	}
	
	
	/**
	 * Liefert in Abhänigkeit  von 'RootLabelType' des aktiven Menüs den Text für
	 * das Root-Element  im Pathway.
	 * 
	 * @return String Label für das Pathway-Root-Element
	 */
	public static function getRootElementLabel(){
		$mainframe = JFactory::getApplication();
		$menu = self::getMenuParam();
		if (! is_object($menu)){
			require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'LDConfig.php';
			$ld = new LDConfig();
			return $ld->rootPathWay;
		}
		$menu_params = new JParameter($menu->params);
		$rootLabelTyp = $menu_params->get('RootLabelType');
		switch ($rootLabelTyp){
			case 0:		// Konfiguration
				require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'LDConfig.php';
				$ld = new LDConfig();
				return $ld->rootPathWay;
			case 1:		// RootLabelText aus Menü
				return $menu_params->get('RootLabelText');				
			case 2:		// None
				return '';
			default:	// Global
				return JText::_('LD PATHWAY ROOT LABEL');
		}	
	}
	
	/**
	 * Ermitteln den 'ersten' veröffentlichten Menü-Eintrag , der com_linkdirectory2 enthält.
	 * 
	 * @return MenuItem, oder null, wenn kein Menü-Eintrag gefunden wird.
	 */
	private static function &getMenuParam(){
		$mainframe = JFactory::getApplication();
		$menus	= &JSite::getMenu();
		$component = JComponentHelper::getComponent('com_linkdirectory2');
		$menu	= $menus->getActive();
		if ($menu != null){
			return $menu;
		}
		$menu = $menus->getItems('componentid', $component->id, true);
		return $menu;
	}
	
	/**
	 * Bei $displayDynamicPageTitel = true
	 * 		PAGE_TITEL_FROM MENU - [KATEGORIE] - WEB_LINK_TITEL
	 * Bei $displayDynamicPageTitel = false
	 *      PAGE_TITEL_FROM MENU
	 * @param JParameter $params
	 * @param  $rowWeblink
	 * @param boolean $displayDynamicPageTitel
	 * @return String für den Seitentitel
	 */
	private static function &buildLinkPageTitleForHtmlHead(&$params,&$rowWeblink,$displayDynamicPageTitel){
		$pageTitleFromMenu = $params->get( 'page_title' );
		if ($pageTitleFromMenu){
			$pageTitleFromMenu = $pageTitleFromMenu;
			$separater = ' - ';
		} else {
			$pageTitleFromMenu = '';
			$separater = '';
		}
		if (! $displayDynamicPageTitel){
			return $pageTitleFromMenu;
		}
		if ($rowWeblink->cat_title) {
			$categoryTitel = '['. $rowWeblink->cat_title . '] - ';
		} else {
			$categoryTitel = '[' . strip_tags(self::getRootElementLabel()) . '] - ';
		}
		$title = $pageTitleFromMenu  . $separater . $categoryTitel  .' ' . $rowWeblink->title;
		return $title; 
	}
	
	/**
	 * Bei $displayDynamicPageTitel = true
	 *     PAGE_TITEL_FROM MENU - [ KATEGORIE_TITEL] oder
	 * Bei $displayDynamicPageTitel = false
	 *     PAGE_TITEL_FROM MENU
	 * @param unknown_type $params
	 * @param unknown_type $parentCategoryTitle
	 * @param unknown_type $displayDynamicPageTitel
	 * @return unknown_type
	 */
	private static function &buildCategoiesPageTitleForHtmlHead(&$params,&$parentCategoryTitle,$displayDynamicPageTitel){
		$pageTitleFromMenu = $params->get( 'page_title' );
		
		if ($pageTitleFromMenu){
			$pageTitleFromMenu = $pageTitleFromMenu ;
			$separater = ' - ';
		} else {
			$pageTitleFromMenu = '';
			$separater = '';
		}
		if (! $displayDynamicPageTitel){
			return $pageTitleFromMenu;
		}	
		if ($parentCategoryTitle ) {
			$categoryTitel = '['. $parentCategoryTitle . '] ';
		} else {
			$categoryTitel = '['. strip_tags(self::getRootElementLabel()) . '] ';
		}
		$result = $pageTitleFromMenu . $separater . $categoryTitel;
		return $result; 	 
	}
	
	private static function &buildSearchPageTitleForHtmlHead(&$params,&$searchText,$displayDynamicPageTitel){
		$pageTitleFromMenu = $params->get( 'page_title' );
		
		if ($pageTitleFromMenu){
			$pageTitleFromMenu = $pageTitleFromMenu ;
			$separater = ' - ';
		} else {
			$pageTitleFromMenu = '';
			$separater = '';
		}
		if (! $displayDynamicPageTitel){
			return $pageTitleFromMenu;
		}	
		$searchTitel = JText::_('Search of') .' ['. $searchText . '] ';
		$title =  $pageTitleFromMenu . $separater . $searchTitel;
		return $title;	 
	}
	
	/**
	 * Liefert JParamter, wo 'page_title' auf den Wert des Menü 
	 * gesetzt ist oder wenn dies leer ist, JText::_( 'LINK DIRECTORY 2 PAGE TITLE' ) 
	 * @return JParamter mit gesetztem Parameter 'page_title'  
	 */
	private static function &getPageTitleFromMenu(){
		$mainframe = JFactory::getApplication();
		$menu	= self::getMenuParam();
		$params = &$mainframe->getParams();

		$show_page_title = false;
		if (is_object( $menu )) {
			$menu_params = new JParameter( $menu->params );
			if ($menu_params->get( 'show_page_title')) {
				$show_page_title=true;
			}
			if (!$menu_params->get( 'page_title')) {
				$params->set('page_title',	JText::_( 'LINK DIRECTORY 2 PAGE TITLE' ));
			}
		} else {
			$params->set('page_title',	JText::_( 'LINK DIRECTORY 2 PAGE TITLE') );
		}
		return $params;
	}
	
		
	/**
	 * Liefert die URL für "Add Link"
	 * @param String $view View, in dem der Link angezeigt werden soll 'link' oder 'categories'
	 * @param int    $sid Id des Links bzw. der Kategorie  
	 * @param int    $defaultCategory Id der Default-Kategorie
	 * @return URL
	 */
	public static function getUrlForAddNewLink($view, $sid,$defaultCategory){
		if (self::isAddNewLinkAllowedForCurrentUser()){
			return JRoute::_('index.php?option=com_linkdirectory2&view=link&task=add&source='.$view.'&sid='.$sid.'&catid='.$defaultCategory);
		} else {
			return '';
		}
	}

	/**
	 * Liefert true, wenn der User einen neuen Link einreichen darf.
	 * @return boolean true, wenn User einen neuen Link einreichen darf
	 */
	public static function isAddNewLinkAllowedForCurrentUser(){
		$user 	=& JFactory::getUser();
		require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'LDConfig.php';
		$ld = new LDConfig();
		$allowaddGid = $ld->allowadd;
		if ( ($allowaddGid < 0 ) or ($allowaddGid > 25)  ){
			return false;
		}		
		if ( $user->gid < $allowaddGid ){
			return false;
		}
		return true;
	}
	
	/**
	 * Liefert true, wenn User Links mit HTML anlegen darf, sonst false.
	 * @return boolean true, wenn User Link mit HTML anlegen darf.
	 */
	public static function isAddNewLinkWithHtmlAllowed(){
		if (self::isAddNewLinkAllowedForCurrentUser()) {
			$user 	=& JFactory::getUser();
			if ($user->gid > 18 ) { // Registered
				return true;
			}
		}
		return false;
	}	
}

?>